﻿Option Strict On
Imports System.Xml.Linq

Partial Public Class MainPage
    Inherits PhoneApplicationPage

    ' コンストラクター
    Public Sub New()
        InitializeComponent()
    End Sub

    Const AppID As String = "Bing Maps Account Centerより取得したApplicationID"

    Dim xmldoc As XElement
    Dim prefName As String = String.Empty

    Private Sub MainPage_Loaded(sender As Object, e As System.Windows.RoutedEventArgs) Handles MyBase.Loaded

        xmldoc = XElement.Load("pref.xml")
        Dim prefList As New List(Of String)

        For Each result In From c In xmldoc.Descendants("都道府県") Select c
            prefList.Add(result.Value)
        Next
        prefListBox.ItemsSource = prefList
    End Sub

    Private Sub Button1_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles Button1.Click
        Dim myUri As String = String.Format("http://dev.virtualearth.net/REST/v1/Locations?countryRegion=JP&adminDistrict={0}&locality={1}&addressLine={2}&key={3}&c=ja-jp&o=xml", prefName, HttpUtility.UrlEncode(cityTextBox.Text), HttpUtility.UrlEncode(numberTextBox.Text), AppID)
        Dim myWebClient As New WebClient
        myWebClient.DownloadStringAsync(New Uri(myUri, UriKind.Absolute))

        AddHandler myWebClient.DownloadStringCompleted, Sub(resultSender As Object, resultArgs As DownloadStringCompletedEventArgs)
                                                            Dim readXmldoc As String = resultArgs.Result
                                                            readXmldoc = readXmldoc.Replace("xmlns:xsi=" & ChrW(34) & "http://www.w3.org/2001/XMLSchema-instance" & ChrW(34) & " xmlns:xsd=" & ChrW(34) & "http://www.w3.org/2001/XMLSchema" & ChrW(34) & " xmlns=" & ChrW(34) & "http://schemas.microsoft.com/search/local/ws/rest/v1" & ChrW(34), "")
                                                            Dim doc As XElement = XElement.Parse(readXmldoc)
                                                            Dim addressName As String = HttpUtility.UrlEncode(doc.Descendants("Location").Elements("Name").Value)
                                                            Dim myLatitude As String = HttpUtility.UrlEncode(doc.Descendants("Point").Elements("Latitude").Value)
                                                            Dim myLongitude As String = HttpUtility.UrlEncode(doc.Descendants("Point").Elements("Longitude").Value)

                                                            NavigationService.Navigate(New Uri(String.Format("/MapPage.xaml?latitude={0}&longitude={1}&name={2}", myLatitude, myLongitude, addressName), UriKind.Relative))
                                                        End Sub
    End Sub

    Private Sub prefListBox_SelectionChanged(sender As Object, e As System.Windows.Controls.SelectionChangedEventArgs) Handles prefListBox.SelectionChanged
        If prefListBox.SelectedIndex >= 0 Then
            prefName = HttpUtility.UrlEncode(prefListBox.SelectedItem.ToString)
        Else
            MessageBox.Show("都道府県を選択してください。")
        End If
    End Sub
End Class
